/* 
 Теоретичні питання
 1. Опишіть своїми словами як працює метод forEach.
 2. Які методи для роботи з масивом мутують існуючий масив, а які повертають новий масив? Наведіть приклади. 
 3. Як можна перевірити, що та чи інша змінна є масивом? 
 4. В яких випадках краще використовувати метод map(), а в яких forEach()?

 Практичні завдання
 1. Створіть масив з рядків "travel", "hello", "eat", "ski", "lift" та обчисліть кількість рядків з довжиною більше за 3 символи. Вивести це число в консоль.
 
 2. Створіть масив із 4 об'єктів, які містять інформацію про людей: {name: "Іван", age: 25, sex: "чоловіча"}. Наповніть різними даними. Відфільтруйте його, щоб отримати тільки об'єкти зі sex "чоловіча". 
 Відфільтрований масив виведіть в консоль.

 3. Реалізувати функцію фільтру масиву за вказаним типом даних. (Опціональне завдання)

Технічні вимоги:

- Написати функцію filterBy(), яка прийматиме 2 аргументи. Перший аргумент - масив, який міститиме будь-які дані, другий аргумент - тип даних.
- Функція повинна повернути новий масив, який міститиме всі дані, які були передані в аргумент, за винятком тих, тип яких був переданий другим аргументом. Тобто якщо передати масив ['hello', 'world', 23, '23', null], і другим аргументом передати 'string', то функція поверне масив [23, null].
 */

/* 

Теория

1) метод форич перебирает масив значений и что-то с ними делает либо возвращает

2) Методы которые мутируют массив = splice / pop / push / shift / unshift / sort / reverse / fill . Методы которые не мутируют массив = map / filter / slice / concat / reduce / join / every / some .

3) методом глобального обьекта Array.isArray();

4) Мап используется когда нужно вытащить какие-то значения и вернуть новый массив трансформируя его(при этом старый массив не меняется), фор ич перебирает массив и что-то возвращает 

*/

// Практика 

// 1 

const arr = ['travel', 'hello', 'eat', 'ski', 'lift'];

const longArr = arr.filter(arr => arr.length > 3);

console.log(longArr.length);


// 2 

const users = [{name: "Іван", age: 25, sex: "чоловіча"},{name: "Василь", age: 25, sex: "чоловіча"},{name: "Карина", age: 25, sex: "жіноча"},{name: "Anna", age: 25, sex: "жіноча"}];

const filteredUsers = users.filter((user) => {
    if(user.sex === 'чоловіча') {
        return user;
    }
})
console.log(filteredUsers);

